%include %{_rpmconfigdir}/macros.python2

Summary: The YUM package manager
Name: yum

%define major 3.4
%define fix 3

Version: %{major}.%{fix}
Release: 22
License: GPL-2.0-only
URL: http://yum.baseurl.org

BuildArch: noarch

Source0: http://yum.baseurl.org/download/%{major}/yum-%{version}.tar.gz

Patch6: yum-%{version}-yum-utils.patch
Patch7: yum-%{version}-setopt.patch

Patch9: yum-ibmi-authority.patch
Patch10: yum-fix-arch.patch
Patch11: yum-no-var-run.patch
Patch12: yum-fix-username.patch
Patch13: yum-ibmi-releasever.patch

BuildRequires: python2
BuildRequires: gettext-runtime

# NOTE: yum doesn't install under the python directory, so automatic dependency
#       generation doesn't work and we have to manually specify it here
Requires: python(abi) = %{py_ver}
Requires: yum-metadata-parser
Requires: python2-iniparse
Requires: python2-rpm
Requires: python2-urlgrabber
Requires: ibmi-repos

%description
Yum is an automatic updater and package installer/remover for rpm systems. It
automatically computes dependencies and figures out what things should occur to
install packages. It makes it easier to maintain groups of machines without
having to manually update each one using rpm. Yum has a plugin interface for
adding simple features. Yum can also be used from other python programs via its
module inteface.

%prep
%setup -q

cp rpmUtils/arch.py .

%patch9 -p1
%patch10 -p1
%patch11 -p1
# need to hold off until we figure out why /usr/bin/id invocations end up with a failure in /QOpenSys/pkgs/bin/id 
%patch12 -p1
%patch13 -p1

cp -p Makefile Makefile.bak

# Fix shebang line
find . -name \*.py | xargs perl -p -i -e 's|/usr/bin/python|%{_bindir}/python2|g'

# Change /usr/* paths to the right prefix
perl -p -i -e 's|/usr/bin|%{_bindir}|g; s|/usr/sbin|%{_sbindir}|g; s|/usr/share/man|%{_mandir}|g; s|/usr/share|%{_datadir}|g; s|/etc|%{_sysconfdir}|g;  s|/var|%{_localstatedir}|g;' \
    rpmUtils/Makefile \
    etc/Makefile \
    Makefile \
    docs/Makefile \
    po/Makefile \
    yum/Makefile \
    yum/config.py \
    yum/plugins.py \
    yum/misc.py \
    yum/rpmsack.py \
    yum/__init__.py \
    etc/yum.bash \
    etc/yum.conf \
    bin/yum.py
    #end

# rm Makefile.bak

# Change /etc to /QOpenSys/etc
perl -p -i -e 's|/etc/yum|%{_sysconfdir}/yum|g' \
    docs/yum.8 \
    docs/yum.conf.5 \
    docs/yum-updatesd.conf.5 \
    cli.py \
    rpmUtils/arch.py \
    #end

find . -type f | xargs touch -r Makefile.bak

%build

%make_build PYTHON=python2

%install

%make_install PYTHON=python2

rm %{buildroot}%{_sbindir}/yum-updatesd
rm %{buildroot}%{_mandir}/man5/yum-updatesd.conf.5
rm %{buildroot}%{_sysconfdir}/yum/yum-updatesd.conf
rm %{buildroot}%{_sysconfdir}/yum/yum-daily.yum
rm %{buildroot}%{_sysconfdir}/yum/yum-weekly.yum
rm %{buildroot}%{_sysconfdir}/cron.daily/0yum.cron
rm -r %{buildroot}%{_sysconfdir}/dbus-1/

mkdir %{buildroot}%{_sysconfdir}/yum/pluginconf.d
mkdir %{buildroot}%{_datadir}/yum-plugins


# TODO: figure out where to ship these
rm -r %{buildroot}%{_sysconfdir}/bash_completion.d



%files
%defattr(-, qsys, *none)

%license COPYING

%{_bindir}/yum

%{_mandir}/man5/yum.conf.5*
%{_mandir}/man8/yum.8*
%{_mandir}/man8/yum-shell.8*
%{_mandir}/man8/yum-updatesd.8*

%{_datadir}/yum-cli/arch.py
%{_datadir}/yum-cli/arch.pyc
%{_datadir}/yum-cli/yumcommands.py
%{_datadir}/yum-cli/output.py
%{_datadir}/yum-cli/yummain.py
%{_datadir}/yum-cli/shell.py
%{_datadir}/yum-cli/utils.py
%{_datadir}/yum-cli/callback.py
%{_datadir}/yum-cli/cli.py
%{_datadir}/yum-cli/callback.pyc
%{_datadir}/yum-cli/cli.pyc
%{_datadir}/yum-cli/output.pyc
%{_datadir}/yum-cli/shell.pyc
%{_datadir}/yum-cli/utils.pyc
%{_datadir}/yum-cli/yumcommands.pyc
%{_datadir}/yum-cli/yummain.pyc
%{_datadir}/yum-cli/yumupd.pyc
%{_datadir}/yum-cli/yumupd.py

%{_datadir}/locale/bn_IN/LC_MESSAGES/yum.mo
%{_datadir}/locale/ca/LC_MESSAGES/yum.mo
%{_datadir}/locale/cs/LC_MESSAGES/yum.mo
%{_datadir}/locale/da/LC_MESSAGES/yum.mo
%{_datadir}/locale/de/LC_MESSAGES/yum.mo
%{_datadir}/locale/el/LC_MESSAGES/yum.mo
%{_datadir}/locale/en_GB/LC_MESSAGES/yum.mo
%{_datadir}/locale/es/LC_MESSAGES/yum.mo
%{_datadir}/locale/eu/LC_MESSAGES/yum.mo
%{_datadir}/locale/fi/LC_MESSAGES/yum.mo
%{_datadir}/locale/fr/LC_MESSAGES/yum.mo
%{_datadir}/locale/gu/LC_MESSAGES/yum.mo
%{_datadir}/locale/hi/LC_MESSAGES/yum.mo
%{_datadir}/locale/hu/LC_MESSAGES/yum.mo
%{_datadir}/locale/id/LC_MESSAGES/yum.mo
%{_datadir}/locale/id_ID/LC_MESSAGES/yum.mo
%{_datadir}/locale/it/LC_MESSAGES/yum.mo
%{_datadir}/locale/ja/LC_MESSAGES/yum.mo
%{_datadir}/locale/lt_LT/LC_MESSAGES/yum.mo
%{_datadir}/locale/mr/LC_MESSAGES/yum.mo
%{_datadir}/locale/ms/LC_MESSAGES/yum.mo
%{_datadir}/locale/nb/LC_MESSAGES/yum.mo
%{_datadir}/locale/pa/LC_MESSAGES/yum.mo
%{_datadir}/locale/pl/LC_MESSAGES/yum.mo
%{_datadir}/locale/pt/LC_MESSAGES/yum.mo
%{_datadir}/locale/pt_BR/LC_MESSAGES/yum.mo
%{_datadir}/locale/ru/LC_MESSAGES/yum.mo
%{_datadir}/locale/sr/LC_MESSAGES/yum.mo
%{_datadir}/locale/sr@latin/LC_MESSAGES/yum.mo
%{_datadir}/locale/sv/LC_MESSAGES/yum.mo
%{_datadir}/locale/uk/LC_MESSAGES/yum.mo
%{_datadir}/locale/ur/LC_MESSAGES/yum.mo
%{_datadir}/locale/zh_CN/LC_MESSAGES/yum.mo
%{_datadir}/locale/zh_TW/LC_MESSAGES/yum.mo

%{py_sitedir}/rpmUtils
%{py_sitedir}/yum

%dir %{_sysconfdir}/yum
%dir %{_sysconfdir}/yum/pluginconf.d

%config(noreplace) %{_sysconfdir}/yum/yum.conf
%config(noreplace) %{_sysconfdir}/yum/version-groups.conf

# %{_sysconfdir}/logrotate.d/yum
# %{_sysconfdir}/rc.d/init.d/yum-updatesd
# %{_sysconfdir}/rc.d/init.d/yum-cron
# %{_sysconfdir}/dbus-1/system.d/yum-updatesd.conf
# %{_sysconfdir}/cron.daily/0yum.cron
# %{_sysconfdir}/sysconfig/yum-cron

# %{_sysconfdir}/bash_completion.d/yum.bash

%dir %{_datadir}/yum-plugins

%dir /QOpenSys/var/cache/yum
%dir /QOpenSys/var/lib/yum
%exclude %{_sysconfdir}/logrotate.d/yum
%exclude %{_sysconfdir}/rc.d/init.d/yum-updatesd
%exclude %{_sysconfdir}/rc.d/init.d/yum-cron
%exclude %{_sysconfdir}/dbus-1/system.d/yum-updatesd.conf
%exclude %{_sysconfdir}/cron.daily/0yum.cron
%exclude %{_sysconfdir}/sysconfig/yum-cron


%changelog
* Wed Nov 03 2021 Abdirahim Musse <abdirahim.musse@ibm.com>
- Add requirement on ibmi-repos package

* Wed Nov 18 2020 Abdirahim Musse <abdirahim.musse@ibm.com> - 
- Stop using /unix for auth check

* Wed May 27 2020 Kevin Adler <kadler@us.ibm.com>
- Use generic paths for man and info pages to allow for compression

* Mon Dec 9 2019 - Abdirahim Musse <abdirahim.musse@ibm.com>
- Update SPDX license identifier

* Thu Jan 03 2019 - Kevin Adler <kadler@us.ibm.com>
- Automatically set $releasever

* Mon Dec 31 2018 - Kevin Adler <kadler@us.ibm.com>
- Add iniparse dependency and use SPDX license

* Wed Aug 08 2018 - Kevin Adler <kadler@us.ibm.com>
- Fix glib2-devel dependencies

* Sat Aug 04 2018 - Kevin Adler <kadler@us.ibm.com>
- Ship yum plugin directories

* Fri Apr 13 2018 - Jesse R. Gorzinski <jgorzins@us.ibm.com>
- Add yum-fix-username.patch

* Mon Mar 12 2018 - Kevin Adler <kadler@us.ibm.com>
- Do not ship devel sub package
- Do not ship 0yum.cron file and dbus-1 directory
- For now, don't ship bash completion files

* Tue Mar 06 2018 - Kevin Adler <kadler@us.ibm.com>
- Move yum pid file to /QOpenSys/etc and don't overwrite yum.conf

* Sat Mar 03 2018 - Kevin Adler <kadler@us.ibm.com>
- Use perl -pie instead of GNU sed -i

* Fri Feb 23 2018 - Kevin Adler <kadler@us.ibm.com>
- Enable *ALLOBJ checking for yum

* Sat Feb 17 2018 - Kevin Adler <kadler@us.ibm.com>
- Add build requirements and use python2 for yum build

* Fri Feb 16 2018 - Kevin Adler <kadler@us.ibm.com>
- Remove unneeded yum locale workaround

* Wed Dec 20 2017 - Kevin Adler <kadler@us.ibm.com>
- Add missing dependencies
- Fix paths in rpmsack.py
- Set locale to UTF-8 if not set
- Add understanding of 'fat' architecture

* Wed Nov 22 2017 - Kevin Adler <kadler@us.ibm.com>
- Build yum
